package service

import (
	"errors"

	entity "gitlab.com/mbugroup/lti-api.git/internal/entities"
	repository "gitlab.com/mbugroup/lti-api.git/internal/modules/production/recordings/repositories"
	validation "gitlab.com/mbugroup/lti-api.git/internal/modules/production/recordings/validations"
	"gitlab.com/mbugroup/lti-api.git/internal/utils"

	"github.com/go-playground/validator/v10"
	"github.com/gofiber/fiber/v2"
	"github.com/sirupsen/logrus"
	"gorm.io/gorm"
)

type RecordingService interface {
	GetAll(ctx *fiber.Ctx, params *validation.Query) ([]entity.Recording, int64, error)
	GetOne(ctx *fiber.Ctx, id uint) (*entity.Recording, error)
	CreateOne(ctx *fiber.Ctx, req *validation.Create) (*entity.Recording, error)
	UpdateOne(ctx *fiber.Ctx, req *validation.Update, id uint) (*entity.Recording, error)
	DeleteOne(ctx *fiber.Ctx, id uint) error
}

type recordingService struct {
	Log        *logrus.Logger
	Validate   *validator.Validate
	Repository repository.RecordingRepository
}

func NewRecordingService(repo repository.RecordingRepository, validate *validator.Validate) RecordingService {
	return &recordingService{
		Log:        utils.Log,
		Validate:   validate,
		Repository: repo,
	}
}

func (s recordingService) withRelations(db *gorm.DB) *gorm.DB {
	return db.Preload("CreatedUser")
}

func (s recordingService) GetAll(c *fiber.Ctx, params *validation.Query) ([]entity.Recording, int64, error) {
	if err := s.Validate.Struct(params); err != nil {
		return nil, 0, err
	}

	offset := (params.Page - 1) * params.Limit

	recordings, total, err := s.Repository.GetAll(c.Context(), offset, params.Limit, func(db *gorm.DB) *gorm.DB {
		db = s.withRelations(db)
		if params.Search != "" {
			return db.Where("name LIKE ?", "%"+params.Search+"%")
		}
		return db.Order("created_at DESC").Order("updated_at DESC")
	})

	if err != nil {
		s.Log.Errorf("Failed to get recordings: %+v", err)
		return nil, 0, err
	}
	return recordings, total, nil
}

func (s recordingService) GetOne(c *fiber.Ctx, id uint) (*entity.Recording, error) {
	recording, err := s.Repository.GetByID(c.Context(), id, s.withRelations)
	if errors.Is(err, gorm.ErrRecordNotFound) {
		return nil, fiber.NewError(fiber.StatusNotFound, "Recording not found")
	}
	if err != nil {
		s.Log.Errorf("Failed get recording by id: %+v", err)
		return nil, err
	}
	return recording, nil
}

func (s *recordingService) CreateOne(c *fiber.Ctx, req *validation.Create) (*entity.Recording, error) {
	if err := s.Validate.Struct(req); err != nil {
		return nil, err
	}

	createBody := &entity.Recording{
		Name:   req.Name,
	}

	if err := s.Repository.CreateOne(c.Context(), createBody, nil); err != nil {
		s.Log.Errorf("Failed to create recording: %+v", err)
		return nil, err
	}

	return s.GetOne(c, createBody.Id)
}

func (s recordingService) UpdateOne(c *fiber.Ctx, req *validation.Update, id uint) (*entity.Recording, error) {
	if err := s.Validate.Struct(req); err != nil {
		return nil, err
	}

	updateBody := make(map[string]any)

	if req.Name != nil {
		updateBody["name"] = *req.Name
	}

	if len(updateBody) == 0 {
		return s.GetOne(c, id)
	}

	if err := s.Repository.PatchOne(c.Context(), id, updateBody, nil); err != nil {
		if errors.Is(err, gorm.ErrRecordNotFound) {
			return nil, fiber.NewError(fiber.StatusNotFound, "Recording not found")
		}
		s.Log.Errorf("Failed to update recording: %+v", err)
		return nil, err
	}

	return s.GetOne(c, id)
}

func (s recordingService) DeleteOne(c *fiber.Ctx, id uint) error {
	if err := s.Repository.DeleteOne(c.Context(), id); err != nil {
		if errors.Is(err, gorm.ErrRecordNotFound) {
			return fiber.NewError(fiber.StatusNotFound, "Recording not found")
		}
		s.Log.Errorf("Failed to delete recording: %+v", err)
		return err
	}
	return nil
}
